diff --git a/compiler/simplCore/FloatIn.lhs b/compiler/simplCore/FloatIn.lhs
index 8a35749..1c800f5 100644
--- a/compiler/simplCore/FloatIn.lhs
+++ b/compiler/simplCore/FloatIn.lhs
@@ -2,9 +2,9 @@
 % (c) The GRASP/AQUA Project, Glasgow University, 1992-1998
 %
 %************************************************************************
-%*									*
+%*                                                                      *
 \section[FloatIn]{Floating Inwards pass}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 The main purpose of @floatInwards@ is floating into branches of a
@@ -12,12 +12,6 @@ case, so that we don't allocate things, save them on the stack, and
 then discover that they aren't needed in the chosen branch.
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module FloatIn ( floatInwards ) where
 
@@ -25,11 +19,11 @@ module FloatIn ( floatInwards ) where
 
 import CoreSyn
 import MkCore
-import CoreUtils	( exprIsDupable, exprIsExpandable, exprOkForSideEffects )
-import CoreFVs		( CoreExprWithFVs, freeVars, freeVarsOf, idRuleAndUnfoldingVars )
-import Id		( isOneShotBndr, idType )
+import CoreUtils        ( exprIsDupable, exprIsExpandable, exprOkForSideEffects )
+import CoreFVs          ( CoreExprWithFVs, freeVars, freeVarsOf, idRuleAndUnfoldingVars )
+import Id               ( isOneShotBndr, idType )
 import Var
-import Type		( isUnLiftedType )
+import Type             ( isUnLiftedType )
 import VarSet
 import Util
 import UniqFM
@@ -51,9 +45,9 @@ floatInwards dflags = map fi_top_bind
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Mail from Andr\'e [edited]}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 {\em Will wrote: What??? I thought the idea was to float as far
@@ -115,9 +109,9 @@ still left as a let, if the branch is not taken (or b is not entered)
 the closure for a is not built.
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Main floating-inwards code}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -125,12 +119,12 @@ type FreeVarSet  = IdSet
 type BoundVarSet = IdSet
 
 data FloatInBind = FB BoundVarSet FreeVarSet FloatBind
-	-- The FreeVarSet is the free variables of the binding.  In the case
-	-- of recursive bindings, the set doesn't include the bound
-	-- variables.
+        -- The FreeVarSet is the free variables of the binding.  In the case
+        -- of recursive bindings, the set doesn't include the bound
+        -- variables.
 
 type FloatInBinds = [FloatInBind]
-	-- In reverse dependency order (innermost binder first)
+        -- In reverse dependency order (innermost binder first)
 
 fiExpr :: DynFlags
        -> FloatInBinds      -- Binds we're trying to drop
@@ -176,10 +170,10 @@ Note [Floating in past a lambda group]
   there is no risk of duplicating work thereby, but we do need to be
   careful.  In particular, here is a bad case (it happened in the
   cichelli benchmark:
-   	let v = ...
-   	in let f = /\t -> \a -> ...
-   	   ==>
-   	let f = /\t -> let v = ... in \a -> ...
+        let v = ...
+        in let f = /\t -> \a -> ...
+           ==>
+        let f = /\t -> let v = ... in \a -> ...
   This is bad as now f is an updatable closure (update PAP)
   and has arity 0.
 
@@ -206,11 +200,11 @@ Urk! if all are tyvars, and we don't float in, we may miss an
 
 \begin{code}
 fiExpr dflags to_drop lam@(_, AnnLam _ _)
-  | okToFloatInside bndrs 	-- Float in
+  | okToFloatInside bndrs       -- Float in
      -- NB: Must line up with noFloatIntoRhs (AnnLam...); see Trac #7088
   = mkLams bndrs (fiExpr dflags to_drop body)
 
-  | otherwise	 	-- Dump it all here
+  | otherwise           -- Dump it all here
   = wrapFloats to_drop (mkLams bndrs (fiExpr dflags [] body))
 
   where
@@ -218,9 +212,9 @@ fiExpr dflags to_drop lam@(_, AnnLam _ _)
 \end{code}
 
 We don't float lets inwards past an SCC.
-	ToDo: keep info on current cc, and when passing
-	one, if it is not the same, annotate all lets in binds with current
-	cc, change current cc to the new one and float binds into expr.
+        ToDo: keep info on current cc, and when passing
+        one, if it is not the same, annotate all lets in binds with current
+        cc, change current cc to the new one and float binds into expr.
 
 \begin{code}
 fiExpr dflags to_drop (_, AnnTick tickish expr)
@@ -260,12 +254,12 @@ Consider let x=\y....t... in body.  We do not necessarily want to float
 a binding for t into the RHS, because it'll immediately be floated out
 again.  (It won't go inside the lambda else we risk losing work.)
 In letrec, we need to be more careful still. We don't want to transform
-	let x# = y# +# 1#
-	in
-	letrec f = \z. ...x#...f...
-	in ...
+        let x# = y# +# 1#
+        in
+        letrec f = \z. ...x#...f...
+        in ...
 into
-	letrec f = let x# = y# +# 1# in \z. ...x#...f... in ...
+        letrec f = let x# = y# +# 1# in \z. ...x#...f... in ...
 because now we can't float the let out again, because a letrec
 can't have unboxed bindings.
 
@@ -288,27 +282,27 @@ fiExpr dflags to_drop (_,AnnLet (AnnNonRec id rhs@(rhs_fvs, ann_rhs)) body)
   where
     body_fvs = freeVarsOf body `delVarSet` id
 
-    rule_fvs = idRuleAndUnfoldingVars id	-- See Note [extra_fvs (2): free variables of rules]
+    rule_fvs = idRuleAndUnfoldingVars id        -- See Note [extra_fvs (2): free variables of rules]
     extra_fvs | noFloatIntoRhs ann_rhs
-	      || isUnLiftedType (idType id) = rule_fvs `unionVarSet` rhs_fvs
-	      | otherwise		    = rule_fvs
-	-- See Note [extra_fvs (1): avoid floating into RHS]
-	-- No point in floating in only to float straight out again
-	-- Ditto ok-for-speculation unlifted RHSs
+              || isUnLiftedType (idType id) = rule_fvs `unionVarSet` rhs_fvs
+              | otherwise                   = rule_fvs
+        -- See Note [extra_fvs (1): avoid floating into RHS]
+        -- No point in floating in only to float straight out again
+        -- Ditto ok-for-speculation unlifted RHSs
 
     [shared_binds, extra_binds, rhs_binds, body_binds] 
-	= sepBindsByDropPoint dflags False [extra_fvs, rhs_fvs, body_fvs] to_drop
+        = sepBindsByDropPoint dflags False [extra_fvs, rhs_fvs, body_fvs] to_drop
 
-    new_to_drop = body_binds ++				-- the bindings used only in the body
-		  [FB (unitVarSet id) rhs_fvs'
-                      (FloatLet (NonRec id rhs'))] ++ 	-- the new binding itself
-		  extra_binds ++			-- bindings from extra_fvs
-		  shared_binds  			-- the bindings used both in rhs and body
+    new_to_drop = body_binds ++                         -- the bindings used only in the body
+                  [FB (unitVarSet id) rhs_fvs'
+                      (FloatLet (NonRec id rhs'))] ++   -- the new binding itself
+                  extra_binds ++                        -- bindings from extra_fvs
+                  shared_binds                          -- the bindings used both in rhs and body
 
-	-- Push rhs_binds into the right hand side of the binding
+        -- Push rhs_binds into the right hand side of the binding
     rhs'     = fiExpr dflags rhs_binds rhs
     rhs_fvs' = rhs_fvs `unionVarSet` floatedBindsFVs rhs_binds `unionVarSet` rule_fvs
-			-- Don't forget the rule_fvs; the binding mentions them!
+                        -- Don't forget the rule_fvs; the binding mentions them!
 
 fiExpr dflags to_drop (_,AnnLet (AnnRec bindings) body)
   = fiExpr dflags new_to_drop body
@@ -317,34 +311,34 @@ fiExpr dflags to_drop (_,AnnLet (AnnRec bindings) body)
     rhss_fvs = map freeVarsOf rhss
     body_fvs = freeVarsOf body 
 
-	-- See Note [extra_fvs (1,2)]
+        -- See Note [extra_fvs (1,2)]
     rule_fvs = foldr (unionVarSet . idRuleAndUnfoldingVars) emptyVarSet ids
     extra_fvs = rule_fvs `unionVarSet` 
-		unionVarSets [ fvs | (fvs, rhs) <- rhss
-			     , noFloatIntoRhs rhs ]
+                unionVarSets [ fvs | (fvs, rhs) <- rhss
+                             , noFloatIntoRhs rhs ]
 
     (shared_binds:extra_binds:body_binds:rhss_binds) 
-	= sepBindsByDropPoint dflags False (extra_fvs:body_fvs:rhss_fvs) to_drop
+        = sepBindsByDropPoint dflags False (extra_fvs:body_fvs:rhss_fvs) to_drop
 
-    new_to_drop = body_binds ++		-- the bindings used only in the body
-		  [FB (mkVarSet ids) rhs_fvs' 
+    new_to_drop = body_binds ++         -- the bindings used only in the body
+                  [FB (mkVarSet ids) rhs_fvs' 
                       (FloatLet (Rec (fi_bind rhss_binds bindings)))] ++
-					-- The new binding itself
-		  extra_binds ++	-- Note [extra_fvs (1,2)]
-		  shared_binds		-- Used in more than one place
+                                        -- The new binding itself
+                  extra_binds ++        -- Note [extra_fvs (1,2)]
+                  shared_binds          -- Used in more than one place
 
     rhs_fvs' = unionVarSets rhss_fvs `unionVarSet`
-	       unionVarSets (map floatedBindsFVs rhss_binds) `unionVarSet`
-	       rule_fvs		-- Don't forget the rule variables!
+               unionVarSets (map floatedBindsFVs rhss_binds) `unionVarSet`
+               rule_fvs         -- Don't forget the rule variables!
 
     -- Push rhs_binds into the right hand side of the binding
-    fi_bind :: [FloatInBinds]	    -- one per "drop pt" conjured w/ fvs_of_rhss
-	    -> [(Id, CoreExprWithFVs)]
-	    -> [(Id, CoreExpr)]
+    fi_bind :: [FloatInBinds]       -- one per "drop pt" conjured w/ fvs_of_rhss
+            -> [(Id, CoreExprWithFVs)]
+            -> [(Id, CoreExpr)]
 
     fi_bind to_drops pairs
       = [ (binder, fiExpr dflags to_drop rhs) 
-	| ((binder, rhs), to_drop) <- zipEqual "fi_bind" pairs to_drops ]
+        | ((binder, rhs), to_drop) <- zipEqual "fi_bind" pairs to_drops ]
 \end{code}
 
 For @Case@, the possible ``drop points'' for the \tr{to_drop}
@@ -378,21 +372,21 @@ fiExpr dflags to_drop (_, AnnCase scrut case_bndr ty alts)
   = wrapFloats drop_here1 $
     wrapFloats drop_here2 $
     Case (fiExpr dflags scrut_drops scrut) case_bndr ty
-	 (zipWith fi_alt alts_drops_s alts)
+         (zipWith fi_alt alts_drops_s alts)
   where
-	-- Float into the scrut and alts-considered-together just like App
+        -- Float into the scrut and alts-considered-together just like App
     [drop_here1, scrut_drops, alts_drops] 
        = sepBindsByDropPoint dflags False [scrut_fvs, all_alts_fvs] to_drop
 
-	-- Float into the alts with the is_case flag set
+        -- Float into the alts with the is_case flag set
     (drop_here2 : alts_drops_s) = sepBindsByDropPoint dflags True alts_fvs alts_drops
 
     scrut_fvs    = freeVarsOf scrut
     alts_fvs     = map alt_fvs alts
     all_alts_fvs = unionVarSets alts_fvs
     alt_fvs (_con, args, rhs) = foldl delVarSet (freeVarsOf rhs) (case_bndr:args)
-				-- Delete case_bndr and args from free vars of rhs 
-				-- to get free vars of alt
+                                -- Delete case_bndr and args from free vars of rhs 
+                                -- to get free vars of alt
 
     fi_alt to_drop (con, args, rhs) = (con, args, fiExpr dflags to_drop rhs)
 
@@ -408,25 +402,25 @@ noFloatIntoRhs (AnnLam bndr e)
      -- NB: Must line up with fiExpr (AnnLam...); see Trac #7088
    where
      (bndrs, _) = collectAnnBndrs e
-	-- IMPORTANT: don't say 'True' for a RHS with a one-shot lambda at the top.
-	-- This makes a big difference for things like
-	--	f x# = let x = I# x#
-	--	       in let j = \() -> ...x...
-	--		  in if <condition> then normal-path else j ()
-	-- If x is used only in the error case join point, j, we must float the
-	-- boxing constructor into it, else we box it every time which is very bad
-	-- news indeed.
-
-noFloatIntoRhs rhs = exprIsExpandable (deAnnotate' rhs)	
+        -- IMPORTANT: don't say 'True' for a RHS with a one-shot lambda at the top.
+        -- This makes a big difference for things like
+        --      f x# = let x = I# x#
+        --             in let j = \() -> ...x...
+        --                in if <condition> then normal-path else j ()
+        -- If x is used only in the error case join point, j, we must float the
+        -- boxing constructor into it, else we box it every time which is very bad
+        -- news indeed.
+
+noFloatIntoRhs rhs = exprIsExpandable (deAnnotate' rhs) 
        -- We'd just float right back out again...
        -- Should match the test in SimplEnv.doFloatFromRhs
 \end{code}
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{@sepBindsByDropPoint@}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 This is the crucial function.  The idea is: We have a wad of bindings
@@ -448,11 +442,11 @@ We have to maintain the order on these drop-point-related lists.
 sepBindsByDropPoint
     :: DynFlags
     -> Bool             -- True <=> is case expression
-    -> [FreeVarSet]	    -- One set of FVs per drop point
-    -> FloatInBinds 	    -- Candidate floaters
+    -> [FreeVarSet]         -- One set of FVs per drop point
+    -> FloatInBinds         -- Candidate floaters
     -> [FloatInBinds]      -- FIRST one is bindings which must not be floated
-			    -- inside any drop point; the rest correspond
-			    -- one-to-one with the input list of FV sets
+                            -- inside any drop point; the rest correspond
+                            -- one-to-one with the input list of FV sets
 
 -- Every input floater is returned somewhere in the result;
 -- none are dropped, not even ones which don't seem to be
@@ -463,56 +457,56 @@ sepBindsByDropPoint
 type DropBox = (FreeVarSet, FloatInBinds)
 
 sepBindsByDropPoint _ _is_case drop_pts []
-  = [] : [[] | _ <- drop_pts]	-- cut to the chase scene; it happens
+  = [] : [[] | _ <- drop_pts]   -- cut to the chase scene; it happens
 
 sepBindsByDropPoint dflags is_case drop_pts floaters
   = go floaters (map (\fvs -> (fvs, [])) (emptyVarSet : drop_pts))
   where
     go :: FloatInBinds -> [DropBox] -> [FloatInBinds]
-	-- The *first* one in the argument list is the drop_here set
-	-- The FloatInBinds in the lists are in the reverse of
-	-- the normal FloatInBinds order; that is, they are the right way round!
+        -- The *first* one in the argument list is the drop_here set
+        -- The FloatInBinds in the lists are in the reverse of
+        -- the normal FloatInBinds order; that is, they are the right way round!
 
     go [] drop_boxes = map (reverse . snd) drop_boxes
 
     go (bind_w_fvs@(FB bndrs bind_fvs bind) : binds) drop_boxes@(here_box : fork_boxes)
-	= go binds new_boxes
-	where
-	  -- "here" means the group of bindings dropped at the top of the fork
+        = go binds new_boxes
+        where
+          -- "here" means the group of bindings dropped at the top of the fork
 
-	  (used_here : used_in_flags) = [ fvs `intersectsVarSet` bndrs
-					| (fvs, _) <- drop_boxes]
+          (used_here : used_in_flags) = [ fvs `intersectsVarSet` bndrs
+                                        | (fvs, _) <- drop_boxes]
 
-	  drop_here = used_here || not can_push
+          drop_here = used_here || not can_push
 
-		-- For case expressions we duplicate the binding if it is
-		-- reasonably small, and if it is not used in all the RHSs
-		-- This is good for situations like
-		--	let x = I# y in
-		--	case e of
-		--	  C -> error x
-		-- 	  D -> error x
-		--	  E -> ...not mentioning x...
+                -- For case expressions we duplicate the binding if it is
+                -- reasonably small, and if it is not used in all the RHSs
+                -- This is good for situations like
+                --      let x = I# y in
+                --      case e of
+                --        C -> error x
+                --        D -> error x
+                --        E -> ...not mentioning x...
 
-	  n_alts      = length used_in_flags
-	  n_used_alts = count id used_in_flags -- returns number of Trues in list.
+          n_alts      = length used_in_flags
+          n_used_alts = count id used_in_flags -- returns number of Trues in list.
 
-	  can_push = n_used_alts == 1		-- Used in just one branch
-		   || (is_case && 		-- We are looking at case alternatives
-		       n_used_alts > 1 && 	-- It's used in more than one
-		       n_used_alts < n_alts &&	-- ...but not all
-		       floatIsDupable dflags bind) -- and we can duplicate the binding
+          can_push = n_used_alts == 1           -- Used in just one branch
+                   || (is_case &&               -- We are looking at case alternatives
+                       n_used_alts > 1 &&       -- It's used in more than one
+                       n_used_alts < n_alts &&  -- ...but not all
+                       floatIsDupable dflags bind) -- and we can duplicate the binding
 
-	  new_boxes | drop_here = (insert here_box : fork_boxes)
-		    | otherwise = (here_box : new_fork_boxes)
+          new_boxes | drop_here = (insert here_box : fork_boxes)
+                    | otherwise = (here_box : new_fork_boxes)
 
-	  new_fork_boxes = zipWithEqual "FloatIn.sepBinds" insert_maybe fork_boxes used_in_flags
+          new_fork_boxes = zipWithEqual "FloatIn.sepBinds" insert_maybe fork_boxes used_in_flags
 
-	  insert :: DropBox -> DropBox
-	  insert (fvs,drops) = (fvs `unionVarSet` bind_fvs, bind_w_fvs:drops)
+          insert :: DropBox -> DropBox
+          insert (fvs,drops) = (fvs `unionVarSet` bind_fvs, bind_w_fvs:drops)
 
-	  insert_maybe box True  = insert box
-	  insert_maybe box False = box
+          insert_maybe box True  = insert box
+          insert_maybe box False = box
 
     go _ _ = panic "sepBindsByDropPoint/go"
 
